#<profile4xi profile = "12" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "finalizer4xi.py">
#<abstract4xi abstract = "provides class Finalizer4Xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['Finalizer4Xi',
           'clear_finalizer_registry4xi'
           'del_finalizer_registry_element4xi',
           'init_all_finalizer4xi',             
           'init_finalizer_counter4xi',
           'init_finalizer_registry4xi',
           'get_finalizer_counter4xi',                        
           'get_finalizer_registry_element4xi'
           'get_finalizer_registry4xi',
           'next_finalizer_counter4xi'
           'set_finalizer_registry_element4xi']  

#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref
    import atexit         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global object                              
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global _finalizer_registry
global _finalizer_counter
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
_finalizer_registry = {}
_finalizer_counter = itertools.count()
#"
#"/>



 
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "init_finalizer_registry4xi" usage = "
#   syncmanager4xi.py
#       class SyncManager4Xi(BaseManager4Xi):
#           def __init__:
#               init_finalizer_registry4xi()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def init_finalizer_registry4xi():   
    '''
    init_finalizer_registry4xi initializes _finalizer_registry
    '''
    global _finalizer_registry

    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    class2print = "init_finalizer_registry4xi"
    method2print = "init_finalizer_registry4xi"
    
    message2print = "{started" + "; init-finalizer-registry4xi-started: " + str(init_finalizer_registry4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # { init_finalizer_registry4xi : init_finalizer_registry4xi ; started; init-finalizer-registry4xi-started: <function init_finalizer_registry4xi at 0x02DF3C48>; time: 12:06:54 01/07/10 FLE Standard Time}
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    _finalizer_registry = {}
    
    message2print = "{initialized" + "; finalizer-registry-initialized-by-init-finalizer-registry4xi to: " + str(_finalizer_registry)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{returning" + "; init-finalizer-registry4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
#</function4xi>
                     
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "clear-finalizer-registry4xi" usage = "
#     manager4xi.py
#         m2xi = SyncManager4Xi()
#     syncmanager4xi.py
#         class SyncManager4Xi(BaseManager4Xi):
#             def __init__:
#                 init_finalizer_registry4xi() 
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def clear_finalizer_registry4xi():   
    '''
    set_finalizer_registry4xi clears _finalizer_registry
    '''
    global _finalizer_registry

    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    class2print = "clear_finalizer_registry4xi"
    method2print = "clear_finalizer_registry4xi"
    
    message2print = "{started" + "; clear-finalizer-registry4xi-started: " + str(clear_finalizer_registry4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
          
        
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{calling" + "; finalizer-registry-clear-calling-by-clear-finalizer-registry4xi: " + str(_finalizer_registry.clear) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
            
    _finalizer_registry.clear()

    message2print = "{performed" + "; finalizer-registry-clear-performed-by-clear-finalizer-registry4xi: " + str(_finalizer_registry.clear) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
        

        
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{returning" + "; clear-finalizer-registry4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)  
#</function4xi>
         

    
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "get-finalizer-registry4xi" usage = "
# gets _finalizer_registry
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_finalizer_registry4xi():   
    '''
    get_finalizer_registry4xi gets _finalizer_registry
    '''
    global _finalizer_registry

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    class2print = "get_finalizer_registry4xi"
    method2print = "get_finalizer_registry4xi"
    
    message2print = "{started" + "; get-finalizer-registry4xi-started: " + str(get_finalizer_registry4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)            
        
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{returning" + "; finalizer-registry-returning-by-get-finalizer-registry4xi: " + str(_finalizer_registry) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
            
    return _finalizer_registry    
#</function4xi>
 
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "get-finalizer-registry4xi" usage = "
# gets one _finalizer_registry element by a key
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_finalizer_registry_element4xi(key):   
    '''
    get_finalizer_registry_element4xi gets one _finalizer_registry element by a key
    '''
    global _finalizer_registry

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    class2print = "get_finalizer_registry4xi"
    method2print = "get_finalizer_registry4xi"
    
    message2print = "{started" + "; get-finalizer-registry4xi-started: " + str(get_finalizer_registry4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; key-passed-to-get-finalizer-registry4xi: " + str(key) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  
        
    message2print = "{returning" + "; finalizer-registry-key-returning-by-get-finalizer-registry4xi: " + str(_finalizer_registry[key]) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
        
    # { get_finalizer_registry4xi : get_finalizer_registry4xi ; returning _finalizer_registry:
    #   {(None, 1): <finalize4xi: __repr__: Finalize object, callback=free, args=((<arena4xi.Arena4Xi object at 0x00000000034E04E0>, 0, 4096),)>, 
    #    (None, 0): <finalize4xi: __repr__: Finalize object, callback=free, args=((<arena4xi.Arena4Xi object at 0x00000000034E0470>, 0, 4096),)>
    #   }
    # ; time: 10:43:55 06/30/09 FLE Daylight Time}

    
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    return _finalizer_registry[key]       
#</function4xi>
     
        
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "set-finalizer-registry-element4xi" usage = "
# sets a _finalizer_registry element
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_finalizer_registry_element4xi (key, object):   
    '''
    set_finalizer_registry_element4xi sets a _finalizer_registry element
    '''
    global _finalizer_registry

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    class2print = "set_finalizer_registry4xi"
    method2print = "set_finalizer_registry4xi"
    
    message2print = "{started" + "; set-finalizer-registry-element4xi-started: " + str(set_finalizer_registry_element4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{passed" + "; key-passed-to-set-finalizer-registry-element4xi: " + str(key) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; object-passed-to-set-finalizer-registry-element4xi: " + str(object) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                        
          
        
            
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    try:
        _finalizer_registry[key] = object
        
        message2print = "{set" + "; finalizer-registry-set-by-set-finalizer-registry-element4xi to: " + str(_finalizer_registry[key])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
         
    except:
        message2print = "{hit" + "; key-hit-by-set-finalizer-registry-element4xi: " + " *** " + str(key)  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
    message2print = "{returning" + "; set-finalizer-registry-element4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>
                
            
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "del-finalizer-registry4xi" usage = "
# deletes a _finalizer_registry element
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def del_finalizer_registry_element4xi(key):   
    '''
    del_finalizer_registry_element4xi deletes a _finalizer_registry element
    '''
    global _finalizer_registry

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    class2print = "del_finalizer_registry_element4xi"
    method2print = "del_finalizer_registry_element4xi"
    
    message2print = "{started" + "; del-finalizer-registry-element4xi-started: " + str(del_finalizer_registry_element4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; key-passed-to-del-finalizer-registry-element4xi: " + str(key) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                  

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    
    try:
        
        message2print = "{passing" + "; key-passing-to-del-finalizer-registry4xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        message2print = "{deleting" + "; finalizer-registry-element-deleting-by-del-finalizer-registry4xi: " + str(_finalizer_registry[key]) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
            
        del _finalizer_registry[key]

        
    except:
     
 
        message2print = "{hit" + "; key-hit-by-del-finalizer-registry4xi: " + " *** " + str(key)  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
#</function4xi>
              
           
#2#    
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "init-finalizer-counter4xi" usage = "
# #     manager4xi.py
#         m2xi = SyncManager4Xi()
#     syncmanager4xi.py
#         class SyncManager4Xi(BaseManager4Xi):
#             def __init__:
#                 init_finalizer_counter4xi()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def init_finalizer_counter4xi():    
    '''
    init_finalizer_counter4xi initializes _finalizer_counter
    '''
    global _finalizer_counter 

    # -----------------------------------------------------------------------------------------    
    # Step 1/3
    # -----------------------------------------------------------------------------------------    
    
    class2print = "init_finalizer_counter4xi" 
    method2print = "init_finalizer_counter4xi"
    
    message2print = "{(Step 1/3) started" + "; init-finalizer-counter4xi-started: " + str(init_finalizer_counter4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        

    # -----------------------------------------------------------------------------------------    
    # Step 2/3 
    # -----------------------------------------------------------------------------------------    
    
    _finalizer_counter = itertools.count()    

    message2print = "{(Step 2/3) set" + "; finalizer-counter-set-by-init-finalizer-counter4xi to: " + str(_finalizer_counter)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
              
    # { init_finalizer_counter4xi : init_finalizer_counter4xi ; (Step 2/3) set; _finalizer_counter to: count(0); time: 12:14:12 12/01/09 FLE Standard Time}
     
    # -----------------------------------------------------------------------------------------    
    # Step 3/3 
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 3/3) returning" + "; init-finalizer-counter4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                      
    # { init_finalizer_counter4xi : init_finalizer_counter4xi ; (Step 3/3) returning; time: 12:14:12 12/01/09 FLE Standard Time}
#</function4xi>
     
    
               
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "next-finalizer-counter4xi" usage = "
#     finalize4xi.py
#         Finalize4Xi:
#             __init__:
#                  init_finalizer_counter4xi()
#                  self._key = (exitpriority, next_finalizer_counter4xi()) #dragonized next(_finalizer_counter)              
#                  
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def next_finalizer_counter4xi():   
    '''
    next_finalizer_counter4xi return next _finalizer_counter
    '''
    global _finalizer_counter
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    

    class2print = "next_finalizer_counter4xi" 
    method2print = "next_finalizer_counter4xi"
    
    message2print = "{started" + "; next-finalizer-counter4xi-started: " + str(next_finalizer_counter4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
          

    if _finalizer_counter is None:
        init_finalizer_counter4xi()
    
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{returning" + "; next-finalizer-counter4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
            
        
    return next(_finalizer_counter)    
#</function4xi>
 
# ------------------------------------------------------------------------------------------------- 
#<function4xi function = "get-finalizer-counter4xi" usage = "
# gets _finalizer_counter
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_finalizer_counter4xi():   
    '''
    get_finalizer_counter4xi gets _finalizer_counter
    '''
    global _finalizer_counter

    class2print = "get_finalizer_counter4xi"
    method2print = "get_finalizer_counter4xi"
    
    message2print = "{started" + "; get-finalizer-counter4xi-started: " + str(get_finalizer_counter4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
   
    if _finalizer_counter is None:
        init_finalizer_counter4xi()    


    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{returning" + "; _finalizer-counter-returning-by-get-finalizer-counter4xi: " + str(_finalizer_counter) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
                    
    return _finalizer_counter    
#</function4xi>
      
#ALL
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-all-finalizer4xi" usage = "
# initializes all global objects in finalizer4xi
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def init_all_finalizer4xi():          
    '''
    init_all_finalizer4xi initializes all global objects in finalizer4xi
    '''
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    

    class2print = "init_all_finalizer4xi"
    method2print = "init_all_finalizer4xi"
    
    message2print = "{started" + "; init-all-finalizer4xi-started: " + str(init_all_finalizer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # { init_all_finalizer4xi : init_all_finalizer4xi ; started; time: 12:27:04 12/01/09 FLE Standard Time   
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    

    init_finalizer_registry4xi()
    
    init_finalizer_counter4xi()    
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    message2print = "{returning" + "; init-all-finalizer4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
    print4xi(class2print, method2print, message2print)      
    #{ init_all_finalizer4xi : init_all_finalizer4xi ; returning; time: 12:27:04 12/01/09 FLE Standard Time}   
#</function4xi>
     
# =================================================================================================
#<class4xi class = "Finalizer4Xi" base = "object" child = "None" synopsis = "offers services for after fork" usage = "
#
# process4xi.py:
#     f2xi = Finalizer4Xi()"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class Finalizer4Xi(object): #<-- inherits from object class
    ''' 
    Finalizer4Xi offers services for after fork
    '''            
   
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('get_finalizer_counter','set_finalizer_counter','init_finalizer_counter','next_finalizer_counter',
                 'del_finalizer_registry_element','set_finalizer_registry_element','get_finalizer_registry_element',
                 'get_finalizer_registry','clear_finalizer_registry','init_finalizer_registry',
                 'get_all','set_all','init_all','sense', 'reason', 'ace')        
       
    #"
    #/>    
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Finalizer4Xi" usage = "initializes Finalizer4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def __init__(self): 
        '''
        _init__ method initializes Finalizer4Xi
        '''       
        # -----------------------------------------------------------------------------------------
        #           
        # -----------------------------------------------------------------------------------------
        class2print = "Finalizer4Xi"
        method2print = "__init__"
        
        message2print = "{started" + "; init-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
        # { Finalizer4Xi : __init__ ; started; time: 12:05:55 12/01/09 FLE Standard Time}
        
        message2print = "{borning" + "; finalizer2xi-of-Finalizer4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # { Finalizer4Xi : __init__ ; borning; object-of-Finalizer4Xi-borning: <finalizer4xi.Finalizer4Xi object at 0x02BD0110>; time: 14:38:21 01/07/10 FLE Standard Time}
        
        message2print = "{inheriting" + "; object-inheriting-by-finalizer2xi-of-Finalizer4X: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        # -----------------------------------------------------------------------------------------
        #           
        # -----------------------------------------------------------------------------------------
        
        init_all_finalizer4xi()
               
                        
        # -----------------------------------------------------------------------------------------
        #           
        # -----------------------------------------------------------------------------------------
     
        message2print = "{inherited" + "; object-inherited-by-finalizer2xi-of-Finalizer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                                
        message2print = "{activated" + "; finalizer2xi-of-Finalizer4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
   
        #{ Finalizer4Xi : __init__ ; activated; object-of-Finalizer4Xi-activated: <finalizer4xi.Finalizer4Xi object at 0x02BD0110>; time: 14:38:21 01/07/10 FLE Standard Time}
        
        message2print = "{returning; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # { Finalizer4Xi : __init__ ; returning; time: 14:38:21 01/07/10 FLE Standard Time}
    #</methodize4xi>
            
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-all-of-Finalizer4Xi" usage = "initializes after fork">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def init_all(self):
        '''
        init_all method initializes after fork
        '''       
        class2print = "Finalizer4Xi"
        method2print = "init_all"
        
        message2print = "{started" + "; init-all-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        init_all_finalizer4xi()   

        message2print = "{returning" + "; init-all-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                           
    #</methodize4xi>
               
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-all-of-Finalizer4Xi" usage = "sets all after fork">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def set_all(self):
        '''
        set_all method sets all after fork
        '''       
        class2print = "Finalizer4Xi"
        method2print = "set_all"
        
        message2print = "{started" + "; set-all-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        set_all_finalizer4xi() 
        
        message2print = "{returning" + "; set-all-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                         
    #</methodize4xi>
             
    # -------------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-all-of-Finalizer4Xi" usage = "gets all after fork">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------   
    def get_all(self):
        '''
        get_all method gets all after fork
        '''       
        class2print = "Finalizer4Xi"
        method2print = "get_all"
        
        message2print = "{started" + "; get-all-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        message2print = "{returning" + "; get-all-finalizer4xi-function-returning-by-get-all-of-Finalizer4Xi: " + str(get_all_finalizer4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                

        return get_all_finalizer4xi()         
    #</methodize4xi>
        
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "init-finalizer-registry-of-Finalizer4Xi" usage = "initializes _finalizer_registry">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def init_finalizer_registry(self):   
        '''
        init_finalizer_registry initializes _finalizer_registry
        '''
        class2print = "Finalizer4Xi"
        method2print = "init_finalizer_registry"
        
        message2print = "{started" + "; init-finalizer-registry-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

  
        init_finalizer_registry4xi()
        
        message2print = "{returning" + "; init-finalizer-registry-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                             
    #</methodize4xi>
         
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "clear-finalizer-registry-of-Finalizer4Xi" usage = "clears _finalizer_registry">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def clear_finalizer_registry(self):   
        '''
        clear_finalizer_registry clears _finalizer_registry
        '''
        class2print = "Finalizer4Xi"
        method2print = "clear_finalizer_registry"
        
        message2print = "{started" + "; clear-finalizer-registry-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

 
        clear_finalizer_registry4xi()
        
        message2print = "{returning" + "; clear-finalizer-registry-of-Finalizer4X-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                         
                 
                            
    #</methodize4xi>
                   
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "get-finalizer-registry-of-Finalizer4Xi" usage = "gets _finalizer_registry">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def get_finalizer_registry(self):   
        '''
        get_finalizer_registry gets _finalizer_registry
        '''
        class2print = "Finalizer4Xi"
        method2print = "get_finalizer_registry"
        
        message2print = "{started" + "; get-finalizer-registry-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{returning" + "; get-finalizer-registry4xi-function-returning-by-get-finalizer-registry-of-Finalizer4Xi: " + str(get_finalizer_registry4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
              
        return get_finalizer_registry4xi() 
    #</methodize4xi>
    
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "get-finalizer-registry-element-of-Finalizer4Xi" usage = "gets _finalizer_registry element by key">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def get_finalizer_registry_element(self, key):   
        '''
        get_finalizer_registry_element gets _finalizer_registry element by key
        '''
        class2print = "Finalizer4Xi"
        method2print = "get_finalizer_registry_element"
        
        message2print = "{started" + "; get-finalizer-registry-element-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{passed" + "; key-passed-to-get-finalizer-registry-element-of-Finalizer4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                        
        message2print = "{returning" + "; get-finalizer-registry-element4xi-function-returning-by-get-finalizer-registry-element-of-Finalizer4Xi: " + str(get_finalizer_registry_element4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                  
        return get_finalizer_registry_element4xi(key)         
    #</methodize4xi>
                
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "set-finalizer-registry-element-of-Finalizer4Xi" usage = "sets _finalizer_registry element">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def set_finalizer_registry_element(key, object):   
        '''
        set_finalizer_registry sets _finalizer_registry element
        '''
        class2print = "Finalizer4Xi"
        method2print = "set_finalizer_registry_element"
        
        message2print = "{started" + "; set-finalizer-registry-element-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{passed" + "; key-passed-to-set-finalizer-registry-element-of-Finalizer4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{passed" + "; object-passed-to-set-finalizer-registry-element-of-Finalizer4Xi: " + str(object) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
          
        set_finalizer_registry_element4xi(key, object)

        message2print = "{returning" + "; set-finalizer-registry-element-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        

    #</methodize4xi>
              
        
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "del-finalizer-registry-element-of-Finalizer4X" usage = "deletes _finalizer_registry element">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def del_finalizer_registry_element(self, key):   
        '''
        del_finalizer_registry deletes _finalizer_registry element
        '''
        class2print = "Finalizer4Xi"
        method2print = "del_finalizer_registry_element"
        
        message2print = "{started" + "; del-finalizer-registry-element-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        message2print = "{passed" + "; key-passed-to-del-finalizer-registry-element-of-Finalizer4Xi: " + str(key) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                          
        
        del_finalizer_registry_element4xi(key)
        
        message2print = "{returning" + "; del-finalizer-registry-element-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        
    #</methodize4xi>
    
              
    #
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "init-finalizer-counter-of-Finalizer4Xi" usage = "initializes _finalizer_counter">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def init_finalizer_counter(self):   
        '''
        init_finalizer_counter initializes _finalizer_counter
        '''
        class2print = "Finalizer4Xi"
        method2print = "init_finalizer_counter"
        
        message2print = "{started" + "; init-finalizer-counter-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        


        init_finalizer_counter4xi()
        
        message2print = "{returning" + "; init-finalizer-counter-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                            
    #</methodize4xi>
    
             
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "set-finalizer-counter-of-Finalizer4Xi" usage = "sets _finalizer_counter">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def set_finalizer_counter(self):   
        '''
        set_finalizer_counter sets _finalizer_counter
        '''
        class2print = "Finalizer4Xi"
        method2print = "set_finalizer_counter"
        
        message2print = "{started" + "; set-finalizer-counter-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
      

        set_finalizer_counter4xi()
        
        message2print = "{returning" + "; set-finalizer-counter-of-Finalizer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                             
    #</methodize4xi>
                   
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "get-finalizer-counter-of-Finalizer4Xi" usage = "gets _finalizer_counter">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def get_finalizer_counter(self):   
        '''
        get_finalizer_counter gets _finalizer_counter
        '''
        class2print = "Finalizer4Xi"
        method2print = "get_finalizer_counter"
        
        message2print = "{started" + "; get-finalizer-counter-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        message2print = "{returning" + "; get-finalizer-counter4xi-function-returning-by-get-finalizer-counter-of-Finalizer4Xi: " + str(get_finalizer_counter4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
        
        return get_finalizer_counter4xi()          
    #</methodize4xi>
                   
    # ------------------------------------------------------------------------------------------------- 
    #<methodize4xi method = "next-finalizer-counter-of-Finalizer4Xi" usage = "returns next _finalizer_counter">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # -------------------------------------------------------------------------------------------------
    def next_finalizer_counter(self):   
        '''
        returns next _finalizer_counter
        '''
        global _finalizer_counter
        
        class2print = "Finalizer4Xi"
        method2print = "next_finalizer_counter"
        
        message2print = "{started" + "; next-finalizer-counter-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        message2print = "{returning" + "; next-finalizer-counter4xi-function-returning-by-get-finalizer-counter-of-Finalizer4Xi: " + str(next_finalizer_counter4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
        
        return next(_finalizer_counter)         
    #</methodize4xi>
                                                      
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Finalizer4Xi" usage = "senses Finalizer4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Finalizer4Xi class objects
        '''
         
        
        class2print = 'Finalizer4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; Finalizer4Xi-sensing-by-sense-of-Finalizer4Xi: " + str(Finalizer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                      
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Finalizer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        message2print = "{sensed" + "; Finalizer4Xi-sensed-by-sense-of-Finalizer4Xi: " + str(Finalizer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Finalizer4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Finalizer4Xi" usage = "reasons Finalizer4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Finalizer4Xi class objects
        '''
              
        
        class2print = 'Finalizer4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Finalizer4Xi-reasoning-by-reason-of-Finalizer4Xi: " + str(Finalizer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Finalizer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
        message2print = "{reasoned" + "; Finalizer4Xi-reasoned-by-reason-of-Finalizer4Xi: " + str(Finalizer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Finalizer4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                             
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Finalizer4Xi" usage = "aces Finalizer4Xi class objects ">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Finalizer4Xi class objects 
        '''
                 
        
        
        class2print = 'Finalizer4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-Finalizer4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Finalizer4Xi-acing-by-ace-of-Finalizer4Xi: " + str(Finalizer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                       
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Finalizer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Finalizer4Xi-aced-by-ace-of-Finalizer4Xi: " + str(Finalizer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Finalizer4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                   
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
#</methodize4xi>
    
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of finalizer4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>                   

